function [Xr,Yr] = checkdata(X,Y)

disp (' ');
disp(' Checking data matrix X and label vector Y...');

if (length(Y) ~= size(X,1))
    disp(' Number of data points in X and labels in Y are not equal!');
    Xr=0;
    Yr=0;
    return
end

Ys=sort(Y);
yd=diff(Ys);
yi=find(yd);
disp(' Class labels in Y:');
clbls=[Ys(yi);Ys(length(Ys))];
for i=1:length(clbls)
    disp([' ',num2str(clbls(i)),': ',num2str(sum(Y==i)), ' (',num2str(sum(Y==i)/length(Y)*100),' %)']);
end
%disp(clbls);

[Xs,I] = sortrows(X);
Ys=Y(I,:);

Xds = diff(Xs); % differentiate to get variable value changes in sorted x

cidx = find(sum(abs(Xds),2)==0);

if (length(cidx))
    disp(' Found duplicate entries in X.');
    disp(' Removing entries from (SORTED) X at indices:');
    %disp(cidx);
    %for j=1:length(cidx)
    %   if (cidx(j)~=cidx(j+1))
    %       cidx(length(cidx)+1)=cidx(j)+1;
    %   end
    %end
    cidx=[cidx,cidx+1];
    disp(cidx);
    Xr=Xs; Xr(cidx,:)=[];
    Yr=Ys; Yr(cidx,:)=[];
    disp (' Done.');
else
    disp(' Done. No errors found.');
    Xr=Xs;
    Yr=Ys;
end
