function T = grow_tree_recursion(T,X,y,curdepth,maxdepth,tol)

global N; % number of original data points
global nC; % number of original classes
global priors; % prior class probabilities

% next tree node position
position = length(T)+1;

split = findsplit(X,y);
T(position).split = split;

T(position).depth = curdepth;

[clabel,islf,p,r] = nodedata(y,tol);
T(position).p=p; % prob that a certain case falls into this node; = sum(length(y)/N);
T(position).r=r; % resub error prob at current node
T(position).classlabel = clabel; % most probable class label

[Xsmall,Xbig,ysmall,ybig] = divide_x_using_split(X,y,split);

%if ( (size(Xsmall,1) == size(X,1)) | (size(Xbig,1) == size(X,1)) )
%	T(position).smallerchild = -1;
%	T(position).biggerchild = -1;
%	T(position).depth = curdepth;
%	return
%elseif (curdepth == maxdepth) 
if (curdepth == maxdepth) 
	% add smaller child data
    [clabel,islf,p,r] = nodedata(ysmall,tol);
    T(position).smallerchild = -1; % mark as a leaf
    T(position).sclasslabel = clabel; % most probable class label
    T(position).sp=p; % prob that a certain case falls into this node
    T(position).sr=r; % resub error prob at current node
	% add bigger child data
    [clabel,islf,p,r] = nodedata(ybig,tol);
    T(position).biggerchild = -1; % mark as a leaf
    T(position).bclasslabel = clabel; % most probable class label
    T(position).bp=p; % prob that a certain case falls into this node
    T(position).br=r; % resub error prob at current node
	
	return    
else% curdepth ~= maxdepth
    % determine if the left (smaller) child will be a leaf:
	[clabel,islf,p,r] = nodedata(ysmall,tol);
    if (islf)
        % add smaller child data
		T(position).smallerchild = -1; % mark as a leaf
        T(position).sclasslabel = clabel; % most probable class label
        T(position).sp=p; % prob that a certain case falls into this node
        T(position).sr=r; % resub error prob at current node
	else
		T(position).smallerchild = length(T) + 1;	% next node position
		T = grow_tree_recursion(T,Xsmall,ysmall,curdepth+1,maxdepth,tol);
    end
	% determine if the right (bigger) child will be a leaf:
	[clabel,islf,p,r] = nodedata(ybig,tol);
    if (islf)
        % add bigger child data
		T(position).biggerchild = -1; % mark as a leaf
        T(position).bclasslabel = clabel; % most probable class label
        T(position).bp=p; % prob that a certain case falls into this node
        T(position).br=r; % resub error prob at current node
	else
		T(position).biggerchild = length(T) + 1;	% next node position
		T = grow_tree_recursion(T,Xbig,ybig,curdepth+1,maxdepth,tol);
    end
end % if

return
