function T=prune_mcc(T,Xt,yt,sefact)
% minimal cost-complexity pruning

Torig=T;

idx=[];
alf=[];
[idx,alf]=prune_mcc_recursion(T,idx,alf);

[r,mc,mcm,mcmC]=test_tree(T,Xt,yt,0);
[t,nt,R,md] = treeinfo(T);
%disp_tree(T);
mcrs(1)=R;
mct(1)=mc;
cpl(1)=t;
for j=1:length(idx)
    %T=prune(T,idx(j),0);
    T=prune(T,0,alf(j));
    %disp_tree(T);
    [r,mc,mcm,mcmC]=test_tree(T,Xt,yt,0);
    [t,nt,R,md] = treeinfo(T);
        mcrs(j+1)=R;
        mct(j+1)=mc;
        cpl(j+1)=t;
        %disp_tree(T)
end
mcrs=flipdim(mcrs,2);
mct=flipdim(mct,2);
    mcse=sqrt(mct.*(1-mct)/length(yt));
cpl=flipdim(cpl,2);

[tk0,tk0i]=min(mct);
disp(['Minimal cost subtree has: ',num2str(cpl(tk0i)),' terminal nodes']);
disp(['Standard Error of p: ',num2str(mcse(tk0i))]);
disp(['Minimal cost: ',num2str(mct(tk0i))]);
th = mct(tk0i) + sefact*mcse(tk0i);% 1 SE threshold
tk1=tk0;
for k=length(idx):-1:1
    if (mct(k) < th)
        tk1 = mct(k);
    end
end
id=find(mct==tk1);
tk1i=id(1);
disp([num2str(sefact),' SE rule classifier has: ',num2str(cpl(tk1i)),' terminal nodes']);
disp([num2str(sefact),' SE cost: ',num2str(mct(tk1i))]);
T=Torig;
for j=1:length(idx)-tk1i+1
    %T=prune(T,idx(j),0);
    T=prune(T,0,alf(j));
end


xi=1:1:(length(idx)+1);
figure,plot(xi,mcrs,'g-',xi,mct,'r-',tk1i,mct(tk1i),'mo',tk0i,mct(tk0i),'mx');
set(gca,'XTick',1:1:(length(idx)+1));
set(gca,'XTickLabel',cpl);
xlabel('tree complexity: number of terminal nodes');
ylabel('error or misclassification cost');
legend('Resubstitution error','Test-validation error','Estimated best tree size')

%figure,plot(xi,mcse); % standard error

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%555


