function [T,tk1]=prune_mcc_cv(T,X,y,sefact)
% minimal cost-complexity pruning using cross validation

[X,y] = checkdata(X,y); %check data for duplicate entries

n = 10; %n-fold cross validation

cvData=splitdata(X,y,n);

disp(' ');
disp(' Creating subtrees...');
t=[];
for i=1:n
   disp([' Growing subtree number ',num2str(i),' of ',num2str(n),'...']);
   st(i).tree=grow_tree(X(cvData(1,i).l,:),y(cvData(1,i).l));
end


Torig=T;

idx=[];
alf=[];
[idx,alf]=prune_mcc_recursion(T,idx,alf);

mc=test_tree_cv(st,cvData,X,y);
[t,nt,R,md] = treeinfo(T);

mcrs(1)=R;
mct(1)=mc;
cpl(1)=t;
for j=1:length(idx)%-1 %% !!!!!!!!!!!!!!!!!4
    %j
    %T=prune(T,idx(j),0);
    T=prune(T,0,alf(j));
    if (j == length(idx))
        cvalfa=alf(j);
    else
        cvalfa=sqrt(alf(j)*alf(j+1));
    end
    for i=1:n
        st(i).tree=prune(st(i).tree,0,cvalfa);
    end
    %disp_tree(T);
    mc=test_tree_cv(st,cvData,X,y);
    [t,nt,R,md] = treeinfo(T);
        mcrs(j+1)=R;
        mct(j+1)=mc;
        cpl(j+1)=t;
end
mcrs=flipdim(mcrs,2);
mct=flipdim(mct,2);
    mcse=sqrt(mct.*(1-mct)/length(y));
cpl=flipdim(cpl,2);

[tk0,tk0i]=min(mct);
disp(['Minimal cost subtree has: ',num2str(cpl(tk0i)),' terminal nodes']);
disp(['Standard Error of p: ',num2str(mcse(tk0i))]);
th = mct(tk0i) + sefact*mcse(tk0i);% 1 SE threshold
tk1=tk0;
for k=length(idx):-1:1
    if (mct(k) < th)
        tk1 = mct(k);
    end
end
id=find(mct==tk1);
tk1i=id(1);
disp([num2str(sefact),' SE rule classifier has: ',num2str(cpl(tk1i)),' terminal nodes']);
T=Torig;
for j=1:length(idx)-tk1i+1
    %T=prune(T,idx(j),0);
    T=prune(T,0,alf(j));
end


xi=1:1:(length(idx)+1);
figure,plot(xi,mcrs,'g-',xi,mct,'r-',tk1i,mct(tk1i),'mo');
set(gca,'XTick',1:1:(length(idx)+1));
set(gca,'XTickLabel',cpl);
xlabel('tree complexity: number of terminal nodes');
ylabel('error or misclassification cost');
legend('Resubstitution error','Cross-validation error','Estimated best tree size')

%figure,plot(xi,mcse); % standard error

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function rcv=test_tree_cv(t,cvData,X,y)

rcv=[];
for i=1:length(t)
    %i
   [r,mc,mcm,mcmC]=test_tree(t(i).tree,X(cvData(1,i).t,:),y(cvData(1,i).t),0);
   rcv(i)=mc;
end
rcv=mean(rcv);